"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var defaults = {
    now: function () { return Date.now(); },
};
var Defaults = /** @class */ (function (_super) {
    __extends(Defaults, _super);
    function Defaults() {
        var _this = _super.call(this) || this;
        _this.now = function () { return Date.now(); };
        var _loop_1 = function (key) {
            Object.defineProperty(this_1, key, {
                configurable: true,
                get: function () { return defaults[key]; },
                set: function (value) { return _this.emit(Defaults.Events.Changed, key, (defaults[key] = value)); },
            });
        };
        var this_1 = this;
        for (var key in defaults) {
            _loop_1(key);
        }
        return _this;
    }
    Object.defineProperty(Defaults.prototype, "all", {
        get: function () {
            return defaults;
        },
        enumerable: false,
        configurable: true
    });
    Defaults.Events = {
        Changed: 'Changed',
    };
    return Defaults;
}(events_1.EventEmitter));
var instance = new Defaults();
exports.default = instance;
//# sourceMappingURL=defaults.js.map