export default class Server {
    private thread;
    private guid;
    private messages;
    private instance;
    constructor();
    start({ binary, middleware, ...config }: {
        [x: string]: any;
        binary: any;
        middleware: any;
    }): Promise<unknown>;
    stop(force?: boolean): Promise<void>;
    flush(force?: boolean): Promise<unknown>;
    addUser(user: any): Promise<unknown>;
    removeUser(user: any): Promise<unknown>;
    createTask(command: any, user: any): Promise<unknown>;
    subscribe(selector: any, callback: any): Promise<unknown>;
    _task(task: any, args: any, callback?: any): Promise<unknown>;
}
