"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("lodash"));
var defaults_1 = __importDefault(require("../../defaults"));
var types = __importStar(require("../types"));
function default_1(state, props) {
    var _a, _b;
    if (state === void 0) { state = {}; }
    switch (props.type) {
        case types.addUser:
            return __assign(__assign({}, state), (_a = {}, _a[props.user] = {
                id: props.user,
                socket: props.socket,
                timestamp: defaults_1.default.now(),
                folder: props.folder,
                systemFile: undefined,
                stateFiles: [],
                queue: Promise.resolve(),
                actions: 0,
            }, _a));
        case types.removeUser:
            return lodash_1.default.omit(state, props.user);
        case types.updateUser:
            return __assign(__assign({}, state), (_b = {}, _b[props.user] = __assign(__assign(__assign({}, state[props.user]), { timestamp: defaults_1.default.now() }), props.updates), _b));
    }
    return state;
}
exports.default = default_1;
//# sourceMappingURL=users.js.map