import * as workerActions from './actions/worker';
import * as userActions from './actions/user';
import * as taskActions from './actions/task';
import * as globalActions from './actions/global';
export declare const log: typeof globalActions.log;
export declare const info: typeof globalActions.info;
export declare const warn: typeof globalActions.warn;
export declare const error: typeof globalActions.error;
export declare const cleanup: typeof globalActions.cleanup;
export declare const updateGlobals: typeof globalActions.updateGlobals;
export declare const updateConfig: typeof globalActions.updateConfig;
export declare const updateWorker: typeof workerActions.updateWorker;
export declare const handleWorker: typeof workerActions.handleWorker;
export declare const spawnWorker: typeof workerActions.spawnWorker;
export declare const handleUser: typeof userActions.handleUser;
export declare const addUser: typeof userActions.addUser;
export declare const removeUser: typeof userActions.removeUser;
export declare const storeState: typeof userActions.storeState;
export declare const handleTasks: typeof taskActions.handleTasks;
export declare const createTask: typeof taskActions.createTask;
